Imports Excel

'  -  Excel File.
' .       :
', 

Public Class Form1

    Dim fpath$ = System.Windows.Forms.Application.ExecutablePath & "\..\"
    Dim fname$ = " .xls"

    'H   .
    '      DataGridView.
    Dim TableBooks As New System.Data.DataTable

    Dim x As New Excel.Application
    '----------------------------------------
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        On Error Resume Next
        '   
        For Each wbook As Workbook In x.Workbooks
            wbook.Close() : wbook = Nothing
        Next
        x = Nothing

    End Sub
    '----------------------------------------
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '     DataTable
        Dim c As New DataColumn
        c.ColumnName = ""
        c.DataType = GetType(System.String)
        TableBooks.Columns.Add(c)
        c = Nothing

        c = New DataColumn
        c.ColumnName = ""
        c.DataType = GetType(System.Single)
        TableBooks.Columns.Add(c)
        c = Nothing

        '      DataGridView    
        With grdData
            .DataSource = TableBooks
            .ColumnHeadersDefaultCellStyle.Font = New System.Drawing.Font(.Font.FontFamily, .Font.Size, FontStyle.Bold)
            .Columns(0).Width = 180 : .Columns(1).Width = 100
            .Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopRight
            .Columns(1).DefaultCellStyle.Format = "c" 'Currency formated value
        End With

    End Sub
    '----------------------------------------
    '  Excel file (workbook)  Excel.
    Private Sub btnOpenExcelFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenExcelFile.Click

        Try
            x.Workbooks.Open(fpath & fname)
            x.Visible = True

        Catch ex As Exception
            MsgBox("      " & vbCrLf & ex.Message, MsgBoxStyle.Critical)
        End Try

    End Sub
    '----------------------------------------
    '    Grid  Excel file (workbook)   DataTable  workbook.
    Private Sub btnWriteToExcelFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteToExcelFile.Click

        Dim wBook As Workbook
        Dim wSheet As Worksheet

        Try
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            '     .
            wBook = x.Workbooks.Add
            '     
            wSheet = wBook.Worksheets.Add

            '   
            With wSheet
                .Name = " 2006"
                .Range("A1").Value = "" : .Range("B1").Value = ""
                .Range("A1:B1").Font.Name = "Arial"
                .Range("A1:B1").Font.Size = 12
                .Range("A1:B1").Font.Bold = True
                .Range("A1:B1").Font.Color = Microsoft.VisualBasic.RGB(0, 0, 255)
            End With

            Dim cnt% = TableBooks.Rows.Count, i%
            Dim r As DataRow
            'index   
            Dim initSheetDataRow% = 2
            'index  
            Dim SheetSumRow% = initSheetDataRow + cnt + 1

            ' -   DataTable      xcel file (WorkBook).
            With wSheet
                For i = 0 To cnt - 1
                    r = TableBooks.Rows(i)
                    '   
                    .Range("A" & initSheetDataRow + i).Value = r("")
                    .Range("B" & initSheetDataRow + i).Value = r("")
                Next

                '       Sum      
                ' .        .
                .Range("A" & SheetSumRow).Value = " "
                .Range("B" & SheetSumRow).Formula = "=Sum(B" & initSheetDataRow & ":B" & SheetSumRow - 2 & ")"
                .Range("A" & SheetSumRow & ":B" & SheetSumRow).Font.Bold = True
                .Range("B" & initSheetDataRow & ":B" & SheetSumRow - 2, "B" & SheetSumRow).NumberFormat = "#.###,00 "

                .Columns("A:B").Autofit()
                .Columns("B").HorizontalAlignment = XlHAlign.xlHAlignRight
            End With

            '
            wBook.SaveAs(fpath & fname)

            wBook.Close()
            MsgBox("    .xls ")

        Catch ex As Exception
            MsgBox("      " & vbCrLf & ex.Message, MsgBoxStyle.Critical)
        Finally
            System.Windows.Forms.Cursor.Current = Cursors.Default
            wBook = Nothing : wSheet = Nothing
        End Try

    End Sub
    '----------------------------------------
    '    Excel file (workbook)     Grid,   DataTable  workbook
    Private Sub btnReadFromExcelFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadFromExcelFile.Click


        Dim wBook As Workbook
        Dim wSheet As Worksheet
        Dim initSheetDataRow% = 2, i% = 0

        Try
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            wBook = x.Workbooks.Open(fpath & fname)
            wSheet = wBook.Worksheets(" 2006")

            Dim Title$, Timi!
            Dim r As DataRow

            ' i   dataTable.
            TableBooks.Rows.Clear()

            With wSheet
                Title = .Range("A" & initSheetDataRow).Value
                While Title IsNot Nothing
                    Timi = .Range("B" & initSheetDataRow + i).Value
                    '    DataRow
                    r = TableBooks.NewRow
                    r("") = Title : r("") = Timi
                    '    DataTable
                    TableBooks.Rows.Add(r)
                    '  ,  ,   Excel sheet
                    i += 1
                    Title = .Range("A" & initSheetDataRow + i).Value
                End While
            End With
            wBook.Close()

        Catch ex As Exception
            MsgBox("      : " & initSheetDataRow + i & "    Excel" & vbCrLf & ex.Message, MsgBoxStyle.Critical)
        Finally
            System.Windows.Forms.Cursor.Current = Cursors.Default
            wBook = Nothing : wSheet = Nothing
        End Try

    End Sub
    '----------------------------------------
    '  Grid. 
    Private Sub bntResetGrid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bntResetGrid.Click

        '     dataTable.
        TableBooks.Rows.Clear()

    End Sub
    '----------------------------------------
    '   .    Single type.
    Private Sub grdData_CellValidating(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellValidatingEventArgs) Handles grdData.CellValidating

        If e.FormattedValue.ToString = "" Then Exit Sub

        If e.ColumnIndex = 1 Then '
            Try
                Dim _cost! = CSng(e.FormattedValue)
            Catch
                MsgBox("    ", MsgBoxStyle.Information, " ")
                e.Cancel = True
            End Try
        End If

    End Sub
    '------------------------------------------------
End Class
